import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "PipClock.Clock";

function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
end

function RemoveCallback(object, event, callback)
	if not (object == nil) then
		if (object[event] == callback) then
			object[event] = nil;
		else
			if (type(object[event]) == "table") then
				local size = table.getn(object[event]);
				for i = 1, size do
					if (object[event][i] == callback) then
						table.remove(object[event], i);
						break;
					end
				end
			end
		end
	end
end

Turbine.Plugin.Unload = function(self, sender, args)
	Turbine.Shell.WriteLine("Unload Event ... ");
	pipsWindow = nil;
end

player = Turbine.Gameplay.LocalPlayer.GetInstance();
class = player:GetClassAttributes();
effects = player:GetEffects();
fervorPips = Pips();
hazePips = Haze();
currentFervor = FervorWindow();

i = 0;
j = 0;
k = 0;

metronome = function()
	if i == 0 then
		fervorPips:Update(i);
	elseif i == 1 then
		fervorPips:Update(i);
		i = 2;
	elseif i == 2 then
		fervorPips:Update(i);
		i = 3;
	elseif i == 3 then
		fervorPips:Update(i);
		i = 4;
	else
		fervorPips:Update(i);
		i = 1;
	end
end

hazeMetronome = function()
	if j == 0 then
		hazePips:Update(j);
	elseif j == 1 then
		hazePips:Update(j);
		j = 2;
		if (k == 3) then
			hazePips:Update(0);
			RemoveCallback(hazeTimer,"TimeReached",hazeMetronome);
			k = 0;
		end
	elseif j == 2 then
		hazePips:Update(j);
		j = 3;
	elseif j == 3 then
		hazePips:Update(j);
		j = 4;
	elseif j == 4 then
		hazePips:Update(j);
		j = 5;
	elseif j == 5 then
		hazePips:Update(j);
		j = 6;
	elseif j == 6 then
		hazePips:Update(j);
		j = 7;
	elseif j == 7 then
		hazePips:Update(j);
		j = 8;
	elseif j == 8 then
		hazePips:Update(j);
		j = 9;
	elseif j == 9 then
		hazePips:Update(j);
		j = 10;
	elseif j == 10 then
		hazePips:Update(j);
		j = 11;
	elseif j == 11 then
		hazePips:Update(j);
		j = 12;
	elseif j == 12 then
		hazePips:Update(j);
		j = 13;
	elseif j == 13 then
		hazePips:Update(j);
		j = 14;
	elseif j == 14 then
		hazePips:Update(j);
		j = 15;
	else
		hazePips:Update(j);
		j = 1;
		k = k + 1;
	end
end

stance = function()	
	if class:GetStance() == 1 then
		i = 1;
		timer = Timer();
		AddCallback(timer,"TimeReached",metronome);
	else
		fervorPips:Update(0);
		RemoveCallback(timer,"TimeReached",metronome);
		i = 0;
	end
end

haze = function()
	if not (class:GetStance() == 2) then
		if effects:Get(effects:GetCount()):GetName() == "Red Haze" then
			if not (hazeTimer == nil) then
				j = 0;
				k = 0;
				RemoveCallback(hazeTimer,"TimeReached",hazeMetronome);
			end
			j = 1;
			hazeTimer = HazeTimer();
			AddCallback(hazeTimer,"TimeReached",hazeMetronome);
		end
	end
end

AddCallback(class,"StanceChanged",stance);
AddCallback(effects,"EffectAdded",haze);

Turbine.Shell.WriteLine("PipClock 1.0");